'This file was edited with BLIde

SuperStrict

Framework brl.max2d
Import rigz.timelinefx
Import rigz.tweener

'my personal preference is openGL but dx7 and 9 work too.
SetGraphicsDriver GLMax2DDriver()

'We can extend the tlentity type used in the timelinefx mod for our basic game object
Type tVaderEntity Extends tlEntity
	'create a link to the game its created in
	Field game:tVadersGame
End Type
'a player type, extending the vaderentity
Type tPlayer Extends tVaderEntity
	
	'A field to store the effect which the bullets the player shoots will use
	Field bulleteffect:tlEffect
	
	'set the default speed to 200 pixels per second
	Field player_speed:Float = 300
	
	'set the rate of fire, starting off at 5 per second
	Field rate_of_fire:Float = 5
	Field fire_counter:Float	'so we can keep track of the fire rate

	'The create method
	Method Create:tPlayer(_x:Float, _y:Float, shipsprite:String, _game:tVadersGame)
		avatar = LoadSprite(shipsprite)
		setx(_x)
		sety(_y)
		game = _game
		Return Self
	End Method
	
	'Override the update method in tlentity but we will still call super.update at the end of the method
	Method update()
	
		'capture the coordinates so that we can use tweening
		capture()
	
		'Set the current speed to the player speed
		setspeed(player_speed)
		
		'Set the player coordinates to the mouse coordinates
		setx(MouseX())
		sety(MouseY())
		
		'hit by a bullet?
		Local hits:Object[] = CollideRect(x - avatar.width / 4, y - avatar.height / 4 + 5, avatar.width / 2, avatar.height / 2, 2, 0)
		
		'If the player has been hit by a bullet, kill him off!
		For Local b:tBullet = EachIn hits
			'destroy the bullet
			b.Destroy()
			'Set the player status to dead
			dead = True
			'Kill the bullet effect
			'b.effect.hardkill()
			'Copy the explosion effect and set its postion to where ever the player is
			Local explode:tlEffect = CopyEffect(game.effectslib.GetEffect("player explosion"), game.particles)
			explode.setx(x)
			explode.sety(y)
			'Add the effect to the particle manager
			game.particles.addeffect(explode)
			'Its game over man!
			game.gameover = True
		Next
		
		'hit a power up?
		Local powerups:Object[] = CollideRect(x - avatar.width / 4, y - avatar.height / 4 + 5, avatar.width / 2, avatar.height / 2, 4, 0)
		
		'If the player hits a bullet, power him up!
		For Local p:tPowerup = EachIn powerups
			'Kill the power up pill effect
			p.Destroy()
			'copy the "got power up" effect and add it as a child to the player so it stays relative
			addchild(CopyEffect(game.effectslib.GetEffect("got power up"), game.fgparticles))
			'add it to the particle manager
			'And increase the rate of fire by 1
			rate_of_fire:+1
		Next
		
		If MouseDown(1)
			'Rate of fire is measured in shots per second so divide it by the update frequency
			fire_counter:+rate_of_fire / game.tweener.UpdateFrequency
			'As soon as the fire counter is 1 or above a shot is due
			If fire_counter >= 1
				fire_counter:-1
				'create a bullet
				Local b:tBullet = New tBullet.Create(wx, wy, bulleteffect, 1, game)
				'and add it to the list of bullets in the game object
				game.playerbullets.AddLast b
			End If
		End If

		'Let the update method in tlEntity deal with the rest of the mundane updates.
		Super.update
	
	End Method
	
	Method render(tween:Float)
		'make sure the renderer is set back to what we want:
		SetScale 1, 1
		SetColor 255, 255, 255
		SetAlpha 1
		SetBlend ALPHABLEND
		SetRotation 0
		MidHandleImage(avatar.Image)
		'draw it at its tweened world coordinates (wx and wy)
		drawsprite(avatar, TweenValues(oldwx, wx, tween), TweenValues(oldwy, wy, tween))
	End Method

End Type
'A type for the bullets
Type tBullet Extends tVaderEntity
	
	'vader bulet=1 player bullet=2
	Field bullettype:Int
	
	'default bullet speed 1000 pixels per second
	Field bullet_speed:Float = 1000

	Method Create:tBullet(_x:Float, _y:Float, e:tlEffect, _bullettype:Int, _game:tVadersGame)
		setx(_x)
		sety(_y)
		'effect = CopyEffect(e, _game.particles)
		'make the effect a child of the bullet so that it will stay relative to it
		addchild(CopyEffect(e, _game.particles))
		bullettype = _bullettype
		game = _game
		Return Self
	End Method
	
	Method update()
	
		capture()
	
		'set the current speed of the bullet
		setspeed(bullet_speed)
		
		'delete the bullet if it flies off of the screen
		If y < - 10 Or y > GraphicsHeight() + 10 Or x < - 10 Or x > GraphicsWidth() + 10
			destroy()
			Return
		End If
		
		'setup the collision rect
		CollideRect(x - 4, y - 4, 8, 8, 0, bullettype, Self)
		
		Super.update()
	End Method

End Type
'A type for our invaders
Type tVader Extends tVaderEntity

	'The field that stores how fast the vader is turning.
	Field turn:Float
	'A variable to store whether the vader is turning
	Field turning:Int
	
	'Each vader gets a chance to shoot so many times per second. default is once per second
	Field chance_to_shoot_rate:Float = 1
	'the chance to shoot pertentage
	Field chance_to_shoot:Int
	Field shoot_rate_counter:Float = Rnd(1)
	
	'when the vaders appear each round they scale up in size, these store the rate and current scale
	Field scale_rate:Float = 2
	Field scale:Float
	
	'The amount of points awarding for destroying this vader
	Field points:Int
	
	Method Create:tVader(_x:Float, _y:Float, _game:tVadersGame)
		setx(_x)
		sety(_y)
		direction = 90
		game = _game
		Return Self
	End Method
	
	Method update()
		
		capture()
		
		'once the vader reaches the edge of the screen, it does a u-turn:
		If x > 700 Or x < 100 Or turning = True
			turning = True
			direction:+turn / game.tweener.UpdateFrequency
			If direction > 270
				direction = 270
				turn = -turn
				turning = False
			ElseIf direction < 90
				direction = 90
				turn = -turn
				turning = False
			End If
		End If
		
		'if it goes off the edge of the screen kill it
		If y > GraphicsHeight()
			dead = True
		End If
		
		'Scale it up from 0 when it first appears on screen each round
		scale:+scale_rate / game.tweener.UpdateFrequency
		If scale > 1 scale = 1
		
		'Should the vader try taking a shot?
		shoot_rate_counter:+chance_to_shoot_rate / game.tweener.UpdateFrequency
		If shoot_rate_counter >= 1
			shoot_rate_counter = 0
			'once its due a shot, it only as a chance to shot:
			If Rnd(100) > chance_to_shoot
				'create a bullet
				Local b:tBullet = New tBullet.Create(wx, wy, game.vaderbulleteffect, 2, game)
				b.bullet_speed = 200
				b.direction = getdirection(game.player.x, game.player.y, x, y)
				'and add it to the list of bullets in the game object
				game.vaderbullets.AddLast b
			End If
		End If
		
		'hit by a bullet?
		Local hits:Object[] = CollideRect(x - avatar.width / 2, y - avatar.height / 2, avatar.width, avatar.height, 1, 0)
		
		'if its shit by a player bullet then blow it up
		For Local b:tBullet = EachIn hits
			'destroy the bullet
			b.Destroy()
			'set the vader as dead so the game can clean it up
			dead = True
			Local random_explosion:Int = Rnd(1, 3)
			Local explode:tlEffect
			'give a chance of showing 1 of 2 explosion effect just to add a bit of variation
			Select random_explosion
				Case 1
					explode = CopyEffect(game.effectslib.GetEffect("Simple Explosion 1"), game.particles)
				Case 2
					explode = CopyEffect(game.effectslib.GetEffect("Simple Explosion 2"), game.particles)
			End Select
			'set the explosion effect coords to the vaders coords and add the effect to the game particle manager
			explode.setx(x)
			explode.sety(y)
			game.particles.addeffect(explode)
			'tally up the score
			game.score:+points
		Next
		
		Super.update
	End Method
	
	Method render(tween:Float)
		'make sure the renderer is set back to what we want:
		SetScale scale, scale
		SetColor 255, 255, 255
		SetAlpha 1
		SetBlend ALPHABLEND
		SetRotation 0
		MidHandleImage(avatar.Image)
		'draw it at its tweened world coordinates (wx and wy)
		drawsprite(avatar, TweenValues(oldwx, wx, tween), TweenValues(oldwy, wy, tween))
	End Method

End Type
'a type for the saucer that flies along the top
Type tSaucer Extends tVaderEntity

	'The saucer has a bit of health so it can take a few hits
	Field health:Int = 10
	
	Method Create:tSaucer(_x:Float, _y:Float, _game:tVadersGame)
		setx(_x)
		sety(_y)
		direction = 90
		setspeed(50)
		game = _game
		Return Self
	End Method
	
	Method update()
		
		capture()
		
		'hit by a bullet?
		Local hits:Object[] = CollideRect(x - avatar.width / 2, y - avatar.height / 2, avatar.width, avatar.height, 1, 0)
		
		'if its hit by a bullet then damage it and kill it if health becomes 0
		For Local b:tBullet = EachIn hits
			health:-1
			'destroy the bullet
			b.Destroy()
			If health <= 0
				dead = True
				'b.effect.hardkill()
				Local explode:tlEffect
				explode = CopyEffect(game.effectslib.GetEffect("player Explosion"), game.particles)
				'create the explosion and add it to the particle manager
				explode.setx(x)
				explode.sety(y)
				game.particles.addeffect(explode)
				'create a power up left behind by the saucer and add it the game objects list of power ups
				Local p:tPowerup = New tPowerup.Create(x, y, game.powerupeffect, game)
				game.powerups.AddLast(p)
			Else
				'take some damage if it not dead yet
				Local explode:tlEffect
				'copy the damage effect and add it to the particle manager.
				explode = CopyEffect(game.effectslib.GetEffect("damage"), game.particles)
				explode.setx(x)
				explode.sety(y)
				game.particles.addeffect(explode)
			End If
		Next
		
		'if it goes off screen kill the saucer
		If x > GraphicsWidth() + 100 dead = True
		
		Super.update()
		
	End Method
	
	Method render(tween:Float)
		'make sure the renderer is set back to what we want:
		SetScale 1, 1
		SetColor 255, 255, 255
		SetAlpha 1
		SetBlend ALPHABLEND
		SetRotation 0
		MidHandleImage(avatar.Image)
		'draw it at its tweened world coordinates (wx and wy)
		drawsprite(avatar, TweenValues(oldwx, wx, tween), TweenValues(oldwy, wy, tween))
	End Method

End Type
'A type for the powerups that the saucer drops
Type tPowerup Extends tVaderEntity

	Method Create:tPowerup(_x:Float, _y:Float, e:tlEffect, _game:tVadersGame)
		setx(_x)
		sety(_y)
		game = _game
		direction = 180
		addchild(CopyEffect(e, _game.particles))
		setspeed(100)
		Return Self
	End Method
	
	Method update()
	
		capture()
	
		'kill it if it goes off screen
		If y > GraphicsHeight() + 10
			destroy()
			Return
		End If
		
		'setup the collision rect
		CollideRect(x - 8, y - 8, 16, 16, 0, 4, Self)
		
		Super.update()
		
	End Method

End Type
'And the main game type
Type tVadersGame

	Field tweener:tTweener							'The tween object for game timing
	Field particles:tlParticleManager					'The main particle manager for all the explosions and bullets
	Field bgparticles:tlParticleManager				'Particle manager for the background effect of clouds and lightening
	Field fgparticles:tlParticleManager				'Foreground Particle manager for the powerup effect
	Field player:tPlayer							'Player object
	Field saucer:tSaucer							'Saucer Object
	Field effectslib:tlEffectsLibrary					'The effect library
	
	Field playerbullets:TList = CreateList()			'A list to keep track of player bullets
	Field vaderbullets:TList = CreateList()				'A list to keep track of vader bullets
	
	Field vaders:TList = CreateList()					'A list to store all of the vaders
	Field powerups:TList = CreateList()				'A list to keep track of any powerups
	
	Field level:Int								'The current game level 
	
	Field vadersprite1:TAnimImage						'A few variables to store the vader and saucer sprites
	Field vadersprite2:TAnimImage
	Field vadersprite3:TAnimImage
	Field saucersprite:TAnimImage
	
	Field vaderbulleteffect:tlEffect					'Some variables to store bullet and powerup effects
	Field powerupeffect:tlEffect
	Field gotpowerupeffect:tlEffect
	
	Field background:TImage								'Background image
	Field backgroundeffect:tlEffect						'The background effect
	Field titlescreen:tlEffect							'Title screen effect
	
	Field gameover:Int									'True if its game over
	
	Field fpscounter:Int								'Just some fps counters
	Field fps:Int
	Field fpstime:Int = MilliSecs()
	Field fpsdiff:Int
	
	Field score:Int										'score and hi-score values
	Field hiscore:Int
		
	Method newplayer()
		'create a player:
		player = New tPlayer.Create(400, 500, "player.png", Self)
		'and assign the player bullet effect that the player uses
		player.bulleteffect = effectslib.GetEffect("player bullet anim")
	End Method
	
	Method Create:tVadersGame()
	
		'Set the graphics
		Graphics 800, 600
		
		'HideMouse()
		
		'init our vaders gamer, create a tweener and a particle manager
		tweener = New tTweener.Create(30)
		particles = CreateParticleManager()
		'Don't forget to set the updatefrequency!
		SetUpdateFrequency(30)
		'Orient the particles so that screen coords are what we use to position stuff
		particles.SetScreenSize(GraphicsWidth(), GraphicsHeight())
		particles.SetOrigin(GraphicsWidth() / 2, GraphicsHeight() / 2)
		particles.SetIdleTimeLimit(5)
		
		'load the effects library
		'DebugStop
		effectslib = LoadEffects("vadereffects.eff")
		
		'set the effect for the vader bullets
		vaderbulleteffect = effectslib.GetEffect("vader bullet anim")
		
		'load in the vader sprites
		vadersprite1 = loadsprite("vader.png")
		vadersprite2 = loadsprite("vader2.png")
		vadersprite3 = loadsprite("vader3.png")
		saucersprite = loadsprite("saucer.png")
		
		'create a saucer object
		saucer = New tSaucer.Create(-64, 50, Self)
		saucer.dead = True
		
		'Load the background and set up the background particle manager
		background = LoadImage("background.png")
		'create a separate partcile manager for the background particles so they can be drawn behind everything
		bgparticles = CreateParticleManager(100)
		bgparticles.SetScreenSize(GraphicsWidth(), GraphicsHeight())
		bgparticles.SetOrigin(GraphicsWidth() / 2, GraphicsHeight() / 2)
		'set the background effect and add it to the particle manager
		backgroundeffect = CopyEffect(effectslib.GetEffect("background"), bgparticles)
		backgroundeffect.SetAreaSize(GraphicsWidth(), GraphicsHeight())
		'bgparticles.addeffect(backgroundeffect)
		
		'create another particle manager for foreground effects
		fgparticles = CreateParticleManager(100)
		fgparticles.SetScreenSize(GraphicsWidth(), GraphicsHeight())
		fgparticles.SetOrigin(GraphicsWidth() / 2, GraphicsHeight() / 2)
		
		'power up effects
		powerupeffect = effectslib.GetEffect("power up")
		gotpowerupeffect = effectslib.GetEffect("got power up")
		
		'title screen effect
		titlescreen = effectslib.GetEffect("title")
		
		Return Self
		
	End Method
	
	'The main program loop method
	Method run()
	
		'show the title screen
		titleloop()
	
	End Method
	
	Method gameloop()
	
		Local infotoggle:Int = True
		Local backgroundtoggle:Int=False
	
		Local backtotitle:Int
		Local pauseafterdeath:Int
		
		While Not KeyDown(KEY_ESCAPE) And Not backtotitle
			
			Cls
			
			'here is the timing code, update the tweener to get the number of ticks for this loop
			Tweener.Update()
			
			For Local Ticks:Int = 1 To Tweener.FrameTicks
				'Update the execution time for the tweener
				Tweener.UpdateExecutionTime()
				'update the bullets
				ResetCollisions()
				updateplayerbullets()
				updatevaderbullets()
				'update the power ups
				updatepowerups()
				'update the player
				updateplayer()
				'update the vaders and the saucer
				updatevaders()
				updatesaucer()
				'Update the particle managers
				particles.Update()
				bgparticles.Update()
				fgparticles.Update()
				If KeyHit(KEY_F1)
					infotoggle = Not infotoggle
				End If
				If KeyHit(KEY_F2)
					If backgroundtoggle
						backgroundtoggle=False
						bgparticles.clearall()
					Else
						backgroundtoggle=True
						backgroundeffect = CopyEffect(effectslib.GetEffect("background"), bgparticles)
						backgroundeffect.SetAreaSize(GraphicsWidth(), GraphicsHeight())
						bgparticles.addeffect(backgroundeffect)					
					End If
				End If
				
				If gameover
					pauseafterdeath:+1
					If pauseafterdeath > 100
						If MouseHit(1)
							'if its game over then clear out the effects and all the lists so they're clean for the next game
							particles.clearall()
							vaders.Clear()
							clearpowerups()
							clearbullets()
							fgparticles.clearall()
							backtotitle = True
							If score > hiscore
								hiscore = score
							End If
						End If
					End If
				End If
			Next

			'draw the background
			drawbackground()
			bgparticles.DrawParticles(tweener.tween)
			'draw the vaders
			rendervaders(tweener.Tween)
			rendersaucer(tweener.Tween)
			'draw the particles.
			particles.DrawParticles(Tweener.Tween)
			'draw the player
			If Not player.dead
				player.render(tweener.Tween)
			End If
			'draw the foreground
			fgparticles.DrawParticles(Tweener.Tween)
			
			resetstate()
			
			If infotoggle
				DrawText "Press F1 to toggle this info, F2 to toggle background effects", 10, 0
				DrawText "Particles: " + particles.getParticlesInUse(), 10, 10
				DrawText "Effects: " + particles.effects.Count(), 10, 20
				DrawText "FPS: " + get_fps(), 10, 30
			End If

			SetColor 128, 128, 255
			DrawText "Level: " + level, 50, GraphicsHeight() - 20
			DrawText "Score: " + score, 200, GraphicsHeight() - 20
			If score < hiscore
				DrawText "Hi-score: " + hiscore, 350, GraphicsHeight() - 20
			Else
				DrawText "Hi-score: " + score, 350, GraphicsHeight() - 20
			End If
						
			Flip 0
			
		Wend
	End Method
	
	'a basic fps counter
	Method get_fps:Int()
		fpsdiff = MilliSecs() - fpstime
		If fpsdiff >= 1000
			fps = fpscounter
			fpscounter = 0
			fpstime = MilliSecs()
		Else
			fpscounter:+1
		End If
		Return fps
	End Method
	
	'method to show the title screen
	Method titleloop()
		
		Local powerup:tlEffect = CopyEffect(powerupeffect, fgparticles)
		powerup.setx(GraphicsWidth() / 2 + 10)
		powerup.sety(GraphicsHeight() / 2 + 127)
		fgparticles.addeffect(powerup)
		Local title:tlEffect = CopyEffect(titlescreen, fgparticles)
		title.setx(GraphicsWidth() / 2)
		title.sety(GraphicsHeight() / 2 - 75)
		fgparticles.addeffect(title)
		
		While Not KeyDown(KEY_ESCAPE)
			Cls
			
			'timing code
			Tweener.Update()
			
			For Local Ticks:Int = 1 To Tweener.FrameTicks
				'Update the execution time for the tweener
				Tweener.UpdateExecutionTime()
				
				bgparticles.Update()
				fgparticles.Update()
				
				If MouseHit(1)
					newplayer()
					level = 0
					MoveMouse(400, 500)
					fgparticles.clearall()
					gameloop()
					gameover = False
					powerup:tlEffect = CopyEffect(powerupeffect, fgparticles)
					powerup.setx(GraphicsWidth() / 2 + 10)
					powerup.sety(GraphicsHeight() / 2 + 127)
					fgparticles.addeffect(powerup)
					title = CopyEffect(titlescreen, fgparticles)
					title.setx(GraphicsWidth() / 2)
					title.sety(GraphicsHeight() / 2 - 75)
					fgparticles.addeffect(title)
					score = 0
				End If
				
			Next
			drawbackground()
			bgparticles.DrawParticles
			fgparticles.DrawParticles
			
			resetstate()
			SetImageHandle(vadersprite1.Image, 0, 0)
			SetImageHandle(vadersprite2.Image, 0, 0)
			SetImageHandle(vadersprite3.Image, 0, 0)
			SetImageHandle(saucersprite.Image, 0, 0)
			drawsprite vadersprite1, GraphicsWidth() / 2 - 75, GraphicsHeight() / 2
			drawsprite vadersprite2, GraphicsWidth() / 2 - 75, GraphicsHeight() / 2 + 32
			drawsprite vadersprite3, GraphicsWidth() / 2 - 75, GraphicsHeight() / 2 + 64
			drawsprite saucersprite, GraphicsWidth() / 2 - 90, GraphicsHeight() / 2 + 112
			SetColor 128, 128, 255
			DrawText "= 40 points", GraphicsWidth() / 2 - 35, GraphicsHeight() / 2 + 12
			DrawText "= 20 points", GraphicsWidth() / 2 - 35, GraphicsHeight() / 2 + 46
			DrawText "= 10 points", GraphicsWidth() / 2 - 35, GraphicsHeight() / 2 + 76
			DrawText "=", GraphicsWidth() / 2 - 25, GraphicsHeight() / 2 + 120
			DrawText "Hi-score: " + hiscore, GraphicsWidth() / 2 - 45, GraphicsHeight() / 2 + 250
			
			Flip 0
		Wend
	
	End Method
	
	'create a new attack wave
	Method newattackwave()
		
		level:+1
	
		For Local x:Int = 1 To 9
			For Local y:Int = 1 To 5
				Local v:tVader = New tVader.Create(x * 40 + 70, y * 40 + 25, Self)
				Select y
					Case 1
						v.avatar = vadersprite1
						v.points = 40
					Case 2, 3
						v.avatar = vadersprite2
						v.points = 20
					Case 4, 5
						v.avatar = vadersprite3
						v.points = 10
				End Select
				v.setspeed(50 + level * 10)
				v.chance_to_shoot = 95 - level
				v.turn = 180 + level * 10
				v.miniupdate()
				v.capture()
				vaders.AddLast v
			Next
		Next
	
	End Method
	
	'method to update the player bullets
	Method updateplayerbullets()
		For Local b:tBullet = EachIn playerbullets
			If Not b.destroyed
				b.update
			Else
				b.Destroy()
				playerbullets.Remove(b)
			End If
		Next
	End Method
	
	'method to update the bullets shot by invaders
	Method updatevaderbullets()
		For Local b:tBullet = EachIn vaderbullets
			If Not b.destroyed
				b.update
			Else
				b.Destroy()
				vaderbullets.Remove(b)
			End If
		Next
	End Method
	
	'Method to clear the vader and player bullet lists.
	'As we attach effects directly to the bullets, we need to destroy those effects
	'so that particles inuse are returned to the unused list
	Method ClearBullets()
		For Local b:tBullet = EachIn vaderbullets
			b.Destroy()
			vaderbullets.Remove(b)
		Next
		For Local b:tBullet = EachIn playerbullets
			b.Destroy()
			playerbullets.Remove(b)
		Next
	End Method
	
	'method to update the player
	Method updateplayer()
		If Not player.dead
			player.update()
		End If
	End Method
	
	'method to update the vaders
	Method updatevaders()
		If Not vaders.Count()
			newattackwave()
		End If
		For Local v:tVader = EachIn vaders
			If Not v.dead
				v.update()
				If v.dead vaders.Remove v
			End If
		Next
	End Method
	
	'Render all the vaders
	Method rendervaders(tween:Float)
		For Local v:tVader = EachIn vaders
			v.render(tween)
		Next
	End Method
	
	'method to update the saucer
	Method updatesaucer()
		If saucer.dead
			If Int(Rnd(500)) = 50
				saucer = New tSaucer.Create(-64, 20, Self)
				saucer.avatar = saucersprite
				saucer.miniupdate()
				saucer.capture()
			End If
		Else
			saucer.update()
		End If
	End Method
	
	'Render the saucer
	Method rendersaucer(tween:Float)
		If saucer
			If Not saucer.dead
				saucer.render(tween)
			End If
		End If
	End Method
	
	'draw the background gradient image
	Method drawbackground()
		SetScale GraphicsWidth() / Float(ImageWidth(background)), GraphicsHeight() / Float(ImageHeight(background))
		SetColor 255, 255, 255
		SetAlpha 1
		SetBlend SOLIDBLEND
		SetRotation 0
		DrawImage background, 0, 0
	End Method
	
	'method to update the powerups
	Method updatepowerups()
		For Local p:tPowerup = EachIn powerups
			If Not p.destroyed
				p.update
			Else
				p.Destroy()
				powerups.Remove(p)
			End If
		Next
	End Method
	
	'just a method to cleanup the powerups after a game ends
	Method clearpowerups()
		For Local p:tPowerup = EachIn powerups
			p.Destroy
			powerups.Remove(p)
		Next
	End Method

	'method to reset the render states
	Method resetstate()
		SetScale 1, 1
		SetColor 255, 255, 255
		SetAlpha 1
		SetBlend ALPHABLEND
		SetRotation 0
	End Method
	
End Type

'create and run he game
Local Vaders:tVadersGame = New tVadersGame.Create()
vaders.run()
End